#define pi 3.1415926535
#define MAX_SPEED 0.0006
#define attrNum 10

#define state            0
#define clipnumber       1
#define start            2
#define end              3
#define duration         4
#define weight           5
#define loop             6


int botnumber=0;

////////////////////////////////////////////////////

class bot
{
private:
int id,type,partner,current;
float x,y,velocityx,velocityy,forcex,forcey;
int clipStore[attrNum][2];
float motionStore[attrNum][7];
double rotation;

public:
bot();
~bot();

void rotate(double);
void move(float,float);

void motionsetup(int,int);
void motionchange(int);

void print();
void save(int,int);

float getvalue(int,int);
void setPartner(int);

};

////////////////////////////////////////////////////

bot::bot()
{
id=botnumber;
botnumber+=1;

x = 10.0 * (float) drand48()  / (float) 0x7fffffff; 
y = 10.0 * (float) drand48()  / (float) 0x7fffffff; 

rotation = 170 * (float) drand48() / (float) 0x7fffffff;

cout << id << " " << x << " " << y << " " << rotation <<endl;

current=0;
}

////////////////////////////////////////////////////

bot::~bot(){}

////////////////////////////////////////////////////

void bot::print()
{
for(int i=0;i<attrNum;i++)
{
  
   for(int j=0;j<6;j++){
     switch(j)
    {
       case 0 : cout << "state:  "; break;
       case 1 : cout << "clip :  "; break;
       case 2 : cout << "start:  "; break;
       case 3 : cout << "end  :  "; break;
       case 4 : cout << "dur  :  "; break;
       case 5 : cout << "wei  :  "; break;
       case 6 : cout << "loop :  "; break;
  
    }
    cout << motionStore[i][j] << " ";
    }
   
   cout << endl;
}
}

////////////////////////////////////////////////////

float bot::getvalue(int option, int number)
{

float temp;

switch (option)
{
        case 1: temp=x; break;
        case 2: temp=y; break;
        case 3: temp=rotation; break;
        case 4: temp=id; break;
        case 5: temp=partner; break;	
        case 6: temp=current; break;
        case 7: temp=motionStore[number][clipnumber]; break;
}

return temp;

}

////////////////////////////////////////////////////

void bot::move(float forcex, float forcey)
{
  float mag =  sqrt(  velocityx * velocityx + velocityy*velocityy );

  velocityx+=forcex;
  velocityy+=forcey;

  if (mag > MAX_SPEED * 3)
  {
     velocityx=(velocityx * (MAX_SPEED * 3)) / mag;
     velocityy=(velocityy * (MAX_SPEED * 3)) / mag;
  }

  x+=velocityx;
  y+=velocityy;

  rotation=(atan2(velocityx, velocityy))*(180/pi);

}

////////////////////////////////////////////////////

void bot::rotate(double angle)
{
 double x,y,cosT,sinT; 
 
 rotation+=angle; 
 rotation = fmod(rotation, 360);
 double theta = angle*pi/180.0; 

 cosT=cos(theta);
 sinT=sin(theta);


 x=velocityx*cosT + velocityy*sinT;
 y=velocityy*cosT - velocityx*sinT;

 velocityx=x;
 velocityy=y;
}

////////////////////////////////////////////////////

void bot::save(int frame,int type)
{

ofstream outfile;
char tempname[256];

if (type == 0){
sprintf(tempname, "data_%d.dat", id);

outfile.open(tempname, ios::app);
outfile << frame << "  " << x << 
                    "  " << y << 
                    "  " << rotation << endl; 
}

if (type == 1)
{
sprintf(tempname, "behav_%d.dat", id);
outfile.open(tempname, ios::app);

outfile << "frame: "  << frame << endl;
for(int i=0;i<attrNum;i++)
{
   for(int j=0;j<6;j++) outfile << motionStore[i][j] << " ";
   outfile << endl;

}
outfile << "end" << endl;

}
       
outfile.close();
}


////////////////////////////////////////////////////

void bot::motionsetup(int num, int clipDuration)
{
clipStore[num][0]=num;
clipStore[num][1]=clipDuration;
}


////////////////////////////////////////////////////


void bot::motionchange(int clip)
{

// if state = 0 then the memory slot is empty

if (current<attrNum)
{

if(motionStore[current][state]==0)
{
motionStore[current][clipnumber]=clip;
motionStore[current][duration]=clipStore[clip][1];

// if its the first memory slot then start the clip at the beginning
// else start the clip at the previous clips end time

if (current==0)
    motionStore[current][start]=0;
else
    motionStore[current][start]=motionStore[current-1][end];

// end value is the start plus the duration

motionStore[current][end] = motionStore[current][start] + clipStore[clip][1];

motionStore[current][state] = 1;

current+=1;

}
}
}


////////////////////////////////////////////////////

void bot::setPartner(int val)
{
partner=val;
}




