////////////////////////////////////////////////////
// Author: Greg King
// Version: 
// Date: 14/3/02
// Short Description: Mingle Main Program  
////////////////////////////////////////////////////
#include <GL/glut.h>
#include <GL/glu.h>

#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>

#include "bot.h"

#define xVal 1
#define yVal 2
#define rotVal 3
#define idVal 4
#define partnerVal 5
#define currentS 6
#define motionlookup 7


////////////////////////////////////////////////////

void setup(char *name);
void sim();
void avoid(int botnumber);
void nearestPartner(int botnumber);

void loadData(char *name);

void shape(int type);
void display(void);
void reshape(int w,int h);
void keyboard(unsigned char key, int x, int y);


void shutdown(void);


////////////////////////////////////////////////////

bot *bots;

int saveFlag = 0, 
   numBots=0, 
   frame = 0,

   startSim=0,
   endSim=0,  

   sFrame=200,
   eFrame=500,
   waitOffset=600,

   surfaceAreaX=0,
   surfaceAreaY=0,
  
   attributeNum=0;


int red=0;

////////////////////////////////////////////////////


int main(int argc, char *argv[])
{ 

if (argc < 2)
{
cout << "No filename specified\n";
return 0;
}
else
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   atexit(shutdown);

setup(argv[1]);

   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutKeyboardFunc(keyboard);
   glutIdleFunc(sim);
   glutMainLoop();
   
   return 1;
}

}

////////////////////////////////////////////////////

void shutdown(void)
{
    cout << "shutdown\n";
    fflush(stdout);
    delete [] bots;
}

////////////////////////////////////////////////////


void setup(char *name)
{
    loadData(name);
    srand(time(NULL));
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glShadeModel (GL_SMOOTH);
}

////////////////////////////////////////////////////

void shape(int type)
{
if (type == 1)
{
    glutSolidCube(0.3);
}
else
{
glBegin(GL_POLYGON);
    glVertex3f (0.0,0.0,0.0);
    glVertex3f (0.3,0.0,0.0);
    glVertex3f (0.15,0.0,0.3);
glEnd();

}
}

////////////////////////////////////////////////////

void reshape(int w,int h)
{
   glViewport (0,0, (GLsizei)w, (GLsizei)h);
   glMatrixMode (GL_PROJECTION); 
   glLoadIdentity();
   gluPerspective(40.0, w / h, 1.0, 50.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

////////////////////////////////////////////////////

void display(void)
{
glClear (GL_COLOR_BUFFER_BIT);

// draw all the bots
for(int i=0;i<numBots;i++)
{
glColor3f (1.0, 1.0, 1.0);

if (i==red) glColor3f (1.0, 0.0, 1.0);
if (i==0) glColor3f (0.0, 0.0, 1.0);

        glLoadIdentity();  
	gluLookAt (0.0 , 20.0 ,0.0,
                 0.0, 0.0 ,0.0 ,
		     1.0 ,0.0 ,0.0);
	glPushMatrix();
        glTranslatef (bots[i].getvalue(xVal,0),
                      0,
                      bots[i].getvalue(yVal,0));
        glRotated (bots[i].getvalue(rotVal,0),0,1,0);
        shape(0);
	glPopMatrix();
}


    	glutSwapBuffers();
}

////////////////////////////////////////////////////

void keyboard(unsigned char key, int x, int y)
{
     switch(key)
     { 
     case 27 :  exit(0); break;
     case 'q' : exit(0); break;     
     }
}

////////////////////////////////////////////////////


void sim()
{
// loop from start to end simulation values

       if (frame >= startSim && frame <= endSim) 
        {
        


        if (frame == eFrame)
          {
          eFrame += waitOffset;
          sFrame += waitOffset;
          }

        // loop through all the bots

        for(int i=0;i<numBots;i++){
                if (frame == startSim) bots[i].motionchange(rand() % attrNum);
                
                if (frame == sFrame) nearestPartner(i);
                
                if (frame == eFrame-1)
                {
                int partnerTemp=bots[i].getvalue(partnerVal,0);
                float randomSelection=(bots[partnerTemp].getvalue(currentS,0));
                
                if (randomSelection != 0) randomSelection=rand() % (int)randomSelection;

                int motionLookupSelection=(int)(bots[partnerTemp].getvalue(motionlookup, randomSelection ));

                bots[i].motionchange(motionLookupSelection);
                
                if (i==1) {bots[1].print(); cout << "" << endl;}

                if (saveFlag == 1)   bots[i].save(frame+1,1);

                }

             avoid(i);

             if (saveFlag == 1)
                   if (i==i) bots[i].save(frame,0); 
      
                   
	}
        char tempname[256];

        sprintf(tempname, "scrsave image%04d.sgi 1 600 1 600", frame);

        system(tempname);
        glutPostRedisplay(); 
        frame++; 
  
       	} 
        else
        { 
        cout << "sim ended" << endl;
        exit(0);
        }
}

////////////////////////////////////////////////////


void avoid(int botnumber)
{
    float distance,temp,X1,Y1,X2,Y2,forcex,forcey;

// current bots position
    X1=bots[botnumber].getvalue(xVal,0);
    Y1=bots[botnumber].getvalue(yVal,0);

// loop through all bots

for (int i=0;i<numBots;i++)
{

if(i != botnumber)
{

// selected bots positon
 X2=bots[i].getvalue(xVal,0);
 Y2=bots[i].getvalue(yVal,0);
 temp=(((X1-X2) * (X1-X2)) + ((Y1-Y2) * (Y1-Y2)));
 distance = sqrt(temp);


if (frame > sFrame && frame <= eFrame)
{
  if (i == bots[botnumber].getvalue(partnerVal,0))
  { 
      if (distance > 0.5)
      {
           forcex=(-(0.0006 * (X1-X2)))/distance;
           forcey=(-(0.0006 * (Y1-Y2)))/distance;
           bots[botnumber].move(forcex,forcey);
      }
            
  } else {
      if (distance < 0.3)
      {
           forcex=((0.001 * (X1-X2)))/distance;
           forcey=((0.001 * (Y1-Y2)))/distance;
           bots[botnumber].move(forcex,forcey);
      }  
  }
}  else {

  if (distance<0.9) 
  {
    forcex=((0.0005 * (X1-X2)))/distance;
    forcey=((0.0005 * (Y1-Y2)))/distance;
    bots[botnumber].move(forcex,forcey);
  } else bots[botnumber].move(0,0);
}



// boundary;

if (X1 > surfaceAreaX)
{
float forcex=-(0.00001);
bots[botnumber].move(forcex,0);
}

if (X1 < -surfaceAreaX)
{
float forcex=(0.00001);
bots[botnumber].move(forcex,0);
}

if (Y1 > surfaceAreaY)
{
float forcey=-(0.00001);
bots[botnumber].move(0,forcey);
}

if (Y1 < -surfaceAreaY)
{
float forcey=(0.00001);
bots[botnumber].move(0,forcey);
}


}
else
{
   // do nothing cause it is the current bot 
}   

} // end of if/else 
} // end of func 


////////////////////////////////////////////////////


void nearestPartner(int botnumber)
{
float distanceb=100,X1,Y1,X2,Y2;

    int partner=1;

    X1=bots[botnumber].getvalue(xVal,0);
    Y1=bots[botnumber].getvalue(yVal,0);

float newDistance=50;

for (int j=0;j<numBots;j++){
if(j != botnumber)
{
    X2=bots[j].getvalue(xVal,0);
    Y2=bots[j].getvalue(yVal,0);
    newDistance=sqrt((((X1-X2) * (X1-X2)) + ((Y1-Y2) * (Y1-Y2))));
    
    if(newDistance<distanceb){
        distanceb=newDistance;
        partner=j;
    }
}
}

bots[botnumber].setPartner(partner);

}

////////////////////////////////////////////////////


void loadData(char *name)
{
ifstream infile;
int save,botNum, startT, 
    endT, frameS, frameE, offset;
float surfAreaX, surfAreaY;

if (name == NULL)
{
cout << "no valid input file\n";
}
else
{
infile.open(name, ios::in);

infile >> save >> botNum >> startT >> endT >> frameS >> frameE >> offset
       >> surfAreaX >> surfAreaY >> attributeNum;

int attributes[attributeNum][2];

cout << "number of attributes: " << attributeNum << "\n";

for (int i=0;i<attributeNum;i++)
	{
	infile >> attributes[i][0];
        infile >> attributes[i][1];
        cout << "clip number : " << attributes[i][0] 
             << "   duration" << attributes[i][1] << "\n";
	}


// print stuff

cout << "save : " << save << "\n"
     << "number of characters : " << botNum << "\n" 
     << "start time : " << startT  << "\n"
     << "end time : " << endT << "\n"
     << "max/min X boundry : " << surfAreaX << "\n"
     << "max/min X boundry : " <<  surfAreaY << "\n";

// create bots

bots = new bot[botNum];

//

for (int k=0;k<botNum;k++)
{
for (int j=0;j<attributeNum;j++)
{
        bots[k].motionsetup(attributes[j][0], attributes[j][1]);
}
}

//error checking

if (save==1) saveFlag = 1; else saveFlag = 0;

numBots=botNum; 
startSim=startT;
endSim=endT;   

sFrame=frameS;
eFrame=frameE;
waitOffset=offset;

surfaceAreaX=surfAreaX;
surfaceAreaY=surfAreaY;

infile.close();
}
}






